package com.me.brickbuster.entity;

import com.badlogic.gdx.graphics.Color;
import com.badlogic.gdx.graphics.glutils.ShapeRenderer.ShapeType;
import com.badlogic.gdx.math.Vector2;
import com.me.brickbuster.BrickBuster;

public class Brick extends Entity {
	public static final Color BLOCK_COLOR = Color.FOREST;
	public static final int BLOCK_WIDTH = 50;
	public static final int BLOCK_HEIGHT = 20;

	private Vector2[] vertices;

	public Brick(BrickBuster brickBuster, int x, int y) {
		super(brickBuster, x, y);

		this.vertices = new Vector2[] {
			new Vector2(x, y),
			new Vector2(x + BLOCK_WIDTH, y),
			new Vector2(x + BLOCK_WIDTH, y + BLOCK_HEIGHT),
			new Vector2(x, y + BLOCK_HEIGHT)
		};
	}

	@Override
	public void render() {
		getShapeRenderer().begin(ShapeType.Filled);
		getShapeRenderer().setColor(BLOCK_COLOR);
		getShapeRenderer().rect(getX(), getY(), BLOCK_WIDTH, BLOCK_HEIGHT);
		getShapeRenderer().end();
	}

	@Override
	public void update(float dt) {
	}

	public Vector2[] getVertices() {
		return vertices;
	}

}
