package com.me.brickbuster.entity;

import com.badlogic.gdx.Gdx;
import com.badlogic.gdx.Input;
import com.badlogic.gdx.graphics.Color;
import com.badlogic.gdx.graphics.glutils.ShapeRenderer.ShapeType;
import com.badlogic.gdx.math.Vector2;
import com.me.brickbuster.BrickBuster;
import net.dermetfan.utils.Pair;

public class Paddle extends Entity {

	public static final Color PADDLE_COLOR = Color.BLACK;
	public static final int PADDLE_WIDTH = 100;
	public static final int PADDLE_HEIGHT = 10;
	public static final int PADDLE_Y = 15;
	public static final int PADDLE_SPEED = 6;

	public Paddle(BrickBuster brickBuster) {
		super(brickBuster, BrickBuster.WIDTH / 2 - PADDLE_WIDTH / 2, PADDLE_Y);
	}

	@Override
	public void render() {
		getShapeRenderer().begin(ShapeType.Filled);
		getShapeRenderer().setColor(PADDLE_COLOR);
		getShapeRenderer().rect(getX(), getY(), PADDLE_WIDTH, PADDLE_HEIGHT);
		getShapeRenderer().end();
	}

	@Override
	public void update(float dt) {
		Ball ball = getBrickBuster().getBall();
		if (Gdx.input.isKeyPressed(Input.Keys.LEFT)) {
			if (getX() - PADDLE_SPEED < 0) {
				return;
			}
			setX(getX() - PADDLE_SPEED);
			if (!getBrickBuster().isPlaying()) {
				ball.setX(ball.getX() - PADDLE_SPEED);
			}
		}
		if (Gdx.input.isKeyPressed(Input.Keys.RIGHT)) {
			if (getX() + PADDLE_SPEED + PADDLE_WIDTH > BrickBuster.WIDTH) {
				return;
			}
			setX(getX() + PADDLE_SPEED);
			if (!getBrickBuster().isPlaying()) {
				ball.setX(ball.getX() + PADDLE_SPEED);
			}
		}
	}

	public Pair<Vector2, Vector2> getTopEdge() {
		return new Pair<Vector2, Vector2>(
				new Vector2(getX(), getY() + PADDLE_HEIGHT),
				new Vector2(getX() + PADDLE_WIDTH, getY() + PADDLE_HEIGHT)
		);
	}

}
